// Dan Grossman, CSE303 Spring 2005, Lecture 22
// warning: this code compiles but has not been tested

#include <stdlib.h>

// provides the typedef for list_t and provides a good check that
// are functions have the right types!
#include "lec22.h"

struct LinkedList {
  void * val;
  struct LinkedList * tail;
};

list_t newList(void* _val, list_t _tail) {
  list_t ans = (list_t)malloc(sizeof(struct LinkedList));
  ans->val  = _val;
  ans->tail = _tail;
  return ans;
}

// uses pointer-equality!
int member(list_t lst, void* val) {
  return lst->val == val || (lst->tail != NULL && member(lst->tail,val));
}

// convert an array to a LinkedList
list_t fromArray(int len, void** arr) {
  list_t ans = NULL;
  int i = 0;
  for(; i < len; ++i)
    ans = newList(arr[i], ans);
  return ans;
}

// create a new LinkedList from an old one, subject to filtering
// Note: result is in reverse order from input
// Note: p is passed the env and the val
list_t filter(list_t lst, void* env, int (*p)(void*,void*)) {
  list_t ans = NULL;
  for(; lst != NULL; lst = lst->tail)
    if(p(env,lst->val))
      ans = newList(lst->val,ans);
  return ans;
}

