// Dan Grossman, CSE303 Spring 2005, Lecture 22
// warning: this code compiles but has not been tested

interface Predicate {
  boolean m(Object obj);
}

class LinkedList {
  Object     val;
  LinkedList tail;
  
  public LinkedList(Object _val, LinkedList _tail) {
    val  = _val;
    tail = _tail;
  }

  // uses pointer-equality!
  public boolean member(Object val) {
    return val == this.val || (tail != null && tail.member(val));
  }

  // convert an array to a LinkedList
  public static LinkedList fromArray(Object arr[]) {
    LinkedList ans = null;
    for(int i=0; i < arr.length; ++i)
      ans = new LinkedList(arr[i], ans);
    return ans;
  }

  // create a new LinkedList from an old one, subject to filtering
  // Note: result is in reverse order from input
  public static LinkedList filter(LinkedList lst, Predicate p) {
    LinkedList ans = null;
    for(; lst != null; lst = lst.tail)
      if(p.m(lst.val))
        ans = new LinkedList(lst.val,ans);
    return ans;
  }

}

